package de.intevation.flys.importer;

import java.math.BigDecimal;

import java.util.List;

import org.apache.log4j.Logger;

import org.hibernate.Session;
import org.hibernate.Query;

import de.intevation.flys.model.Depth;


public class ImportDepth {

    private static Logger log = Logger.getLogger(ImportDepth.class);


    protected Depth peer;

    protected BigDecimal lower;
    protected BigDecimal upper;

    protected ImportUnit unit;


    public ImportDepth(BigDecimal lower, BigDecimal upper, ImportUnit unit) {
        this.lower = lower;
        this.upper = upper;
        this.unit  = unit;
    }


    public void storeDependencies() {
        log.info("store dependencies");

        getPeer();
    }


    public Depth getPeer() {
        log.info("get peer");

        if (peer == null) {
            Session session = ImporterSession.getInstance().getDatabaseSession();

            Query query = session.createQuery(
                "from Depth where " +
                "   lower=:lower and " +
                "   upper=:upper and " +
                "   unit=:unit");

            query.setParameter("lower", lower);
            query.setParameter("upper", upper);
            query.setParameter("unit", unit.getPeer());

            List<Depth> depths = query.list();

            if (depths.isEmpty()) {
                log.debug("Create new Depth DB instance.");

                peer = new Depth(lower, upper, unit.getPeer());

                session.save(peer);
            }
            else {
                peer = depths.get(0);
            }
        }

        return peer;
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
